/*
 *    testeh.c   << Teste para o DSP 6001 - Device Driver: Event Handler  Fev. 2001
 *                       Author   : R.V. Ribas
 */

#include <errno.h> 
#include <fcntl.h>
#include <stdio.h> 
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <time.h>

#define CCRESET      16
#define CCREAD16     17
#define CCREAD24     18
#define CCREADV16    19
#define CCWRITE16    20
#define CCWRITE24    21
#define CCDMAI16     22
#define CCWAITLAM    23
#define CCREADEVNT   24
#define CCMAXSIZE    25
#define CCLOADEH     26
#define NAFGEN(n,a,f) (((f << 0x05) | n) | (a << 0x0A))

void  cami16(int, int, int, int *, int *, int *);
void  cami24(int, int, int, int *, int *, int *);
void  camo16(int, int, int, int *, int *, int *);
void  camo24(int, int, int, int *, int *, int *);
int mcami16(int, int, int, short *, int, int *, int *);
int evread16(unsigned int *, unsigned int *, int );
int cc_handle;

main(){

  int N = 10, A = 1, F = 0, D = 0;
  int Q=0,X=0,ierr,arg,i,n,j,k,nbytes;
  int size,cmd;
  time_t  tod;
  char PROG_N[80], DATE[12],TIME[8];
  int NH,NL,NKK,NAUX,KSYS,NSHD,KAUX;
  char evo_name[80];
  unsigned short int DV[4096];
  unsigned char *ioff;
  FILE *fd, *evo; 
  int ni;
  unsigned int xx1,xx2,xx3,xx4;
  char st1[16],st2[16];
  unsigned int instr[1024];

  cc_handle = open ("/dev/cameh0", O_RDWR);
  if (cc_handle == -1){
      printf(" Erro abrindo Crate  \n");
     exit (-1) ;
  }
 
  arg=64;
  ierr = ioctl (cc_handle, CCRESET, (unsigned long) arg);
  D=1;
  
    evo=fopen("tt.evo","r");
    if(evo!=0){
      fscanf(evo,"%d %d %d %d %d %s %s ",&NKK,&NAUX,&KSYS,&NSHD,&KAUX,&DATE,&TIME);
      fscanf(evo,"%76c \n",PROG_N);
      printf("%s \n",PROG_N);
      for(i=0;i<NKK;i++){
       fscanf(evo,"%x  ",&D);
/*     printf(" %d \n",D); */
       instr[i]=D;
       if(instr[i] == 0x2A0000) NH=i+1;  // number of init instructions
      }
     NL = NKK - NH; // number of loop instructions
     printf(" NH,NL = %d %d \n",NH,NL);
     ierr = ioctl(cc_handle, CCLOADEH, (unsigned long) arg);
     ioff = (char *)instr;
     ierr = write (cc_handle,ioff, NH*4); // load first NH instrutions: this is setup
     ierr = ioctl(cc_handle, CCLOADEH, (unsigned long) arg);
     ioff=ioff+33*4;
     ierr = write (cc_handle,ioff, NL*4); //load next NL instructions: this is event loop
     arg=256;
     ierr = ioctl(cc_handle, CCMAXSIZE, (unsigned long) arg);
     arg=0; //Running
     ierr = ioctl(cc_handle, CCRESET, (unsigned long) arg);
     i=0;
     D=0;
     printf(" Starting acquisition...\n");
     while(i++<100){  // loop 100 event buffers
       ierr = ioctl(cc_handle, CCREADEVNT, (unsigned long) arg);
       nbytes = read (cc_handle, DV, 8192);
       if(nbytes>0)printf("i, nwords = %d %d\n",i,nbytes/2);
       if(nbytes < 1)usleep(200000); // fifo was empty - go sleep .2 sec
     }
     arg=4; //Stop
     ierr = ioctl(cc_handle, CCRESET, (unsigned long) arg);
     printf(" Stopping acquisition...\n");
   }

  while (N!=0){
    printf("\n NAF: ");
    ierr=scanf("%d %d %d",&N,&A,&F);
    if(ierr==0)scanf("%x",&N);
    if(N>0&ierr!=0){
      if(F>15){
        printf("Data: ");
        scanf("%d",&D);
        camo24(N,A,F,&D,&Q,&X); 
        printf("Q,X %d %d \n",Q,X);
      }
      else{
        cami24(N,A,F,&D,&Q,&X); 
        printf("\n Q,X,Data: %d %d %d %x \n",Q,X,D,D);
      }
    }
    else if (N==0){
      arg=4;
      ierr = ioctl(cc_handle, CCRESET, (unsigned long) arg);
      close (cc_handle);
      exit(1);
    }
    else {
     N=-N;
     if(N==10){
       ierr = ioctl(cc_handle, CCREADEVNT, (unsigned long) arg);
       ierr = read (cc_handle,DV,4096);
       printf("%d words read\n",ierr);
       for(i=0;i<10;i++)printf("%x  ",DV[i]);
     }
     arg=(N|(A<<8));
     ierr = ioctl(cc_handle, CCRESET, (unsigned long) arg);
    }
  }
  close (cc_handle);
}

void cami16(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCREAD16, (unsigned long) arg);
  QX = read (cc_handle, D, 2);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void cami24(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCREAD24, (unsigned long) arg);
  QX = read (cc_handle, D, 4);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void camo16(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCWRITE16, (unsigned long) arg);
  arg=*D;
  QX = write (cc_handle,(char *) D, 2);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

void camo24(int N, int A, int F, int *D, int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd;
  
  arg  = NAFGEN(N,A,F);
  
  ierr = ioctl (cc_handle, CCWRITE24, (unsigned long) arg);
  arg=*D;
  QX = write (cc_handle,(char *) D, 4);
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>1;
}

int mcami16(int N, int A, int F, short *Dvec, int size,int *Q, int *X)
{
  int arg, QX;
  int ierr,cmd,n;
  
  arg  = NAFGEN(N,A,F)|0x8000;
  
/*  ierr = ioctl (cc_handle, CCREADV16, (unsigned long) arg);*/
  ierr = ioctl (cc_handle, CCREADEVNT, (unsigned long) arg);
  QX = read (cc_handle, (char *)Dvec, size);
  if (QX==-1)return QX;
  *Q=(QX&0x0001);
  *X=(QX&0x0002)>>1;
  return (QX>>2);
}
int evread16(unsigned int *Dvec, unsigned int *Instr, int size)
{
  int arg, nev;
  int ierr,cmd,n;
  unsigned int buff[1024];
  
  arg=0;
  for(n=0;n<size;n++)buff[n]=Instr[n];
  ierr = ioctl (cc_handle, CCREADEVNT, (unsigned long) arg);
  nev = read (cc_handle, (char *)buff, (size<<2));
  printf(" size, nev %d %d \n",size,nev);
  for(n=0;n<nev;n++)Dvec[n]=buff[n];
  return nev;
}

