// ****************************************************************************
// Copyright (C) 2004  Alexandre Suaide
//
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// The Crate Controler Wiener-CC32 is not authorized for use as
// critical component in life support systems without the express
// written approval of ARW Elektronik Germany.
//
// Maintainer(s): Alexandre Suaide (suaide@if.usp.br)
//
// ****************************************************************************
#ifndef __CAMAC_PROTOTYPES__
#define __CAMAC_PROTOTYPES__

  #include "defines.h"
  #include "fops.h"
  #include "asm/delay.h"
  #include "asm/uaccess.h"

  ///////////////////////////////////////////////////////////////////
  // variables
  ////////////////////////////////////////////////////////////////////
	
  static unsigned int nMajor               = 0;
  CC32_DESCRIPTOR *CURRENT                 = NULL;
  char bin[32];

  static volatile short unsigned int cc_buf[BUFFER_SIZE_ARRAY];
  static volatile unsigned int       cc_inst_buf[INSTR_SIZE];
   	
  static int NN,AA,FF;
  static int iev = 0;
  static int MAXSIZE = 512;
  static int EVENT_SIZE = 512;
  static int FLAG[MAX_BUFFER];
  static int NEXTW;
  static int NEXTR;
  static int NBUF;
  static int NBUFFULL = 0;
  static int nwords = 0;
  static int Running = 0;
  static int lost = 0;
  static int lock = 0;
  static int lockEVO = 0;
  static int CC_IO_OP = 0;
  static int USEADACPLUS = 0;
  static int IRQCOUNT = 0;
  
  static unsigned int offset_b = 0;
  	
  ////////////////////////////////////////////////////////////////////
  // prototypes
  ////////////////////////////////////////////////////////////////////
	
  //static int             cc_open(struct inode*,struct file*);
  //static int             cc_release(struct inode*,struct file*);
  //static ssize_t         cc_read(struct file*,char*,size_t,loff_t*);
  //static ssize_t         cc_write(struct file*,const char*,size_t, loff_t*);
  //static int             cc_ioctl(struct inode*,struct file*,unsigned int,unsigned long);
  
   void            read_event_now();
   int             ev_read(unsigned short int []);
  
  int             camo24(int ,int ,int , int);
  int             cami16(int ,int ,int , int *);
  int             cami24(int ,int ,int , int *);
  int             camo16(int ,int ,int , int);
				
  //static void            camcl(CC32_DESCRIPTOR*,int);

#endif
